function fig = gui_adv_segmentation()

% MAIN WINDOW
a = figure( ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Position',[165 50 360 460], ...
	'Units','pixels', ...
	'UserData',struct('Image',0,'Reference',0,'Hoelder',0,'Spectrum',0,'Segmentation',0), ...
	'Tag','gui_segmentation_control_panel');

% TITLE FRAME    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.326086956521739, ...
	'ListboxTop',0, ...
	'Position',[0.02 0.91 0.96 0.08], ...
	'Style','frame', ...
	'Tag','Frame_title');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.521739130434783, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.915 0.8 0.05], ...
	'String','Image Segmentation', ...
	'Style','text', ...
	'Tag','StaticText_Title');

% INPUT FRAME
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.20066889632107, ...
	'Position',[0.02 0.775 0.96 0.13], ...
	'Style','frame', ...
	'Tag','Frame_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.652173913043478, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.84 0.2 0.04], ...
	'String','Input Image', ...
	'Style','text', ...
	'Tag','StaticText_input');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.579710144927536, ...
	'HorizontalAlignment','center', ...
	'Position',[0.32 0.845 0.4 0.045], ...
	'String','', ...
	'Style','edit', ...
	'Enable','inactive',...
	'Tag','EditText_input');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_segmentation(''refresh_input'');', ...
	'FontSize',0.521739130434783, ...
	'FontWeight','bold', ...
	'Position',[0.75 0.84 0.175 0.05], ...
	'String','Refresh', ...
	'Tag','Pushbutton_refreshInput');
    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.652173913043478, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.785 0.25 0.04], ...
	'String','Reference Image', ...
	'Style','text', ...
	'Enable','off',...
	'Tag','StaticText_reference');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.579710144927536, ...
	'HorizontalAlignment','center', ...
	'Position',[0.32 0.79 0.4 0.045], ...
	'String','', ...
	'Enable','off',...
	'Style','edit', ...
	'Enable','inactive',...
	'Tag','EditText_reference');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_segmentation(''refresh_reference'');', ...
	'FontSize',0.521739130434783, ...
	'FontWeight','bold', ...
	'Position',[0.75 0.785 0.175 0.05], ...
	'String','Refresh', ...
	'Enable','off',...
	'Tag','Pushbutton_refreshReference');
% SEGMENTATION FRAME
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.173913043478261, ...
	'Position',[0.02 0.08 0.96 0.15], ...
	'Style','frame', ...
	'Tag','Frame_seg');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.652173913043478, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.18 0.8 0.04], ...
	'String','Segmentation', ...
	'Style','text', ...
	'Tag','StaticText_segmentation');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.652173913043478, ...
	'ListboxTop',0, ...
	'Position',[0.1    0.145    0.19    0.04], ...
	'String','Point type', ...
	'Style','text', ...
	'HorizontalAlignment','left', ...
	'Tag','StaticText_pointType');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_segmentation(''edit_pointType'');', ...
	'FontSize',0.652173913043478, ...
	'ListboxTop',0, ...
	'Position',[0.3    0.15    0.1    0.04], ...
	'String','1', ...
	'Style','edit', ...
	'Tag','EditText_pointType');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.652173913043478, ...
	'ListboxTop',0, ...
	'Position',[0.55    0.145    0.15    0.04], ...
	'String','Spread', ...
	'Style','text', ...
	'HorizontalAlignment','left', ...
	'Tag','StaticText_spread');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_segmentation(''edit_pointType'');', ...
	'FontSize',0.652173913043478, ...
	'ListboxTop',0, ...
	'Position',[0.71    0.15    0.1    0.04], ...
	'String','0.1', ...
	'Style','edit', ...
	'Tag','EditText_spread');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','eval([''global '' fl_segmentation(''computeSegmentation'',who);]);', ...
	'FontSize',0.521739130434783, ...
	'Enable','off',...
	'ListboxTop',0, ...
	'Position',[0.33 0.09 0.34 0.05], ...
	'String','Compute seg.', ...
	'Tag','computeSeg');    


% GENERAL BUTTONS
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','eval([''global '' fl_segmentation(''computeAll'',who);]);', ...
	'FontSize',0.434782608695652, ...
	'Enable','off',...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.03 0.01 0.24 0.06], ...
	'String','Compute all', ...
	'Tag','computeAll');    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_segmentation(''help'');', ...
	'FontSize',0.434782608695652, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.38 0.01 0.24 0.06], ...
	'String','Help', ...
	'Tag','button_help');    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_segmentation(''close'');', ...
	'FontSize',0.434782608695652, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.73 0.01 0.24 0.06], ...
	'String','Close', ...
	'Tag','button_close');

fl_window_init(a); 
    
if nargout > 0, fig = a; end
