% This procedure estimates the 2-microlocal frontier of a signal at
% one point. The algorithm uses an oscillation based characterization
% of 2-microlocal spaces.
%
% The "point to analyse" is the point of the signal where the analysis
% analysis is done.
% 
% The discretization of the frontier is the number of samples that are 
% computed to estimate the frontier. The bigger it is, the more precise
% the approximation is.
%
% An example of estimation is given if desired, i.e. an example of a
% regression which is done to compute a sample of the frontier.
%
% When desired, it also estimates the Pointwise Holder exponent (by 2
% methods) and the local Holder exponent, using the estimated frontier.
%